//     =========================== Navigator.h ==============================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 04.01.2010
//     **********************************************************************


#if !defined(_Navigator_H_INCLUDED_)
#define _Navigator_H_INCLUDED_

#ifdef NAVIGATOR_EXPORTS
#define NAVIGATOR_API __declspec(dllexport)
#else
#define NAVIGATOR_API __declspec(dllimport)
#endif

#include "cv.h"
#include "cxmisc.h"

#define cCmdTotal 8
//    
struct TCmdArray {
	bool Cmd[cCmdTotal];
};

//   
enum {
	cmLEFT = 0,     // 
	cmBACKWARDS,    // 
	cmFORWARD,      // 
	cmRIGHT,        // 
	cmTURRET_RIGHT, //  
	cmFIRE,         // 
	cmTURRET_LEFT,  //  
	cmPOWER         // / 
};

extern NAVIGATOR_API TCmdArray* gpCmdArray;     //   
extern NAVIGATOR_API bool gNovaGateMode;        //    ""
extern NAVIGATOR_API ushort gCheckpointCounter; //    
extern NAVIGATOR_API int gWayIdx;               //  

#pragma pack(push)
#pragma pack(1)

//    
struct TNavigateData {
	int  TurretBalance; //  
	int  MotionSwitch;  //  
};

#define cObjTotalMax 100

//    
struct TRcgObj {
	int    ObjTotal;              //  
	long   ObjIdx[cObjTotalMax];  //   
	CvRect ObjRect[cObjTotalMax]; //     
	double GateHorizon;           //  
	bool   CheckpointFound;       //    
};

#pragma pack(pop)
#pragma pack()

//     
typedef void (*TYPE_LogMessageFunc)(char* apMsg);
typedef TYPE_LogMessageFunc TLogMessageFunc;

//   
typedef void (*TYPE_SetCheckpointFunc)(int, ushort);
typedef TYPE_SetCheckpointFunc TSetCheckpointFunc;

//   
NAVIGATOR_API void Navigate(IplImage* apGray, IplImage* apScreen, TRcgObj* apRcgObj,
							TSetCheckpointFunc SetCheckpoint, TLogMessageFunc LogMessage);
//   
NAVIGATOR_API void StartNavigateMode(bool aNovaGateMode = false);
//   
NAVIGATOR_API void FinishNavigateMode();

#endif // !defined(_Navigator_H_INCLUDED_)